/* 
 *   IMP flex-file
 */

%option noyywrap
 
%{

#include <stdlib.h>
#include "scanner.h"

FILE *g_Plik = NULL;

void yyerror(char *str, ...);

#define YY_INPUT(buf,result,max_size) \
    { \
		if (g_Plik) result = fread( buf, 1, max_size, g_Plik ); \
		else \
		{ \
			int c = getchar(); \
			result = (c == EOF) ? YY_NULL : (buf[0] = c, 1); \
		} \
    }


%}

%% 

[ \t]+                { g_Val.str = " "; return tSTRCONST; }

\n                     { g_Val.str = " "; return tSTRCONST; }


""			{ g_Val.str = "e~"; g_bSam = 1; return tSTRCONST; }
""			{ g_Val.str = "o~"; g_bSam = 1; return tSTRCONST; }
""			{ g_Val.str = "Z"; return tSTRCONST; }
"rz"			{ g_Val.str = "Z"; return tSTRCONST; }
""			{ g_Val.str = "s'"; return tSTRCONST; }
""			{ g_Val.str = "z'"; return tSTRCONST; }
"ch"			{ g_Val.str = "x"; return tSTRCONST; }
"dz"			{ g_Val.str = "dz"; return tSTRCONST; }
"cz"			{ g_Val.str = "tS"; return tSTRCONST; }
"d"			{ g_Val.str = "dZ"; return tSTRCONST; }
""			{ g_Val.str = "ts'"; return tSTRCONST; }
""			{ g_Val.str = "u"; g_bSam = 1; return tSTRCONST; }
"d"			{ g_Val.str = "dz'"; return tSTRCONST; }
""			{ g_Val.str = "n'"; return tSTRCONST; }
""			{ g_Val.str = "w"; return tSTRCONST; }
"nk"			{ g_Val.str = "Nk"; return tGONG; }
"ng"			{ g_Val.str = "Ng"; return tGONG; }
"nch"			{ g_Val.str = "Nx"; return tGONG; }
"sz"			{ g_Val.str = "S"; return tSTRCONST; }



""			{ g_Val.str = "e~"; g_bSam = 1; return tSTRCONST; }
""			{ g_Val.str = "o~"; g_bSam = 1; return tSTRCONST; }
""			{ g_Val.str = "Z"; return tSTRCONST; }
"Rz"			{ g_Val.str = "Z"; return tSTRCONST; }
""			{ g_Val.str = "s'"; return tSTRCONST; }
""			{ g_Val.str = "z'"; return tSTRCONST; }
"Ch"			{ g_Val.str = "x"; return tSTRCONST; }
"Dz"			{ g_Val.str = "dz"; return tSTRCONST; }
"Cz"			{ g_Val.str = "tS"; return tSTRCONST; }
"D"			{ g_Val.str = "dZ"; return tSTRCONST; }
""			{ g_Val.str = "ts'"; return tSTRCONST; }
"D"			{ g_Val.str = "dz'"; return tSTRCONST; }
""			{ g_Val.str = "n'"; return tSTRCONST; }
""			{ g_Val.str = "w"; return tSTRCONST; }
"Nk"			{ g_Val.str = "Nk"; return tGONG; }
"Ng"			{ g_Val.str = "Ng"; return tGONG; }
"Nch"			{ g_Val.str = "Nx"; return tGONG; }
"Sz"			{ g_Val.str = "S"; return tSTRCONST; }
""			{ g_Val.str = "u"; g_bSam = 1; return tSTRCONST; }

"a"			{ g_Val.str = "a"; g_bSam = 1; return tSTRCONST; }
"b"			{ g_Val.str = "b"; return tSTRCONST; }
"c"			{ g_Val.str = "ts"; return tSTRCONST; }
"d"			{ g_Val.str = "d"; return tSTRCONST; }
"e"			{ g_Val.str = "e"; g_bSam = 1; return tSTRCONST; }
"f"			{ g_Val.str = "f"; return tSTRCONST; }
"g"			{ g_Val.str = "g"; return tSTRCONST; }
"h"			{ g_Val.str = "x"; return tSTRCONST; }
"i"			{ g_Val.str = "i"; g_bSam = 1; return tSTRCONST; }
"j"			{ g_Val.str = "j"; return tSTRCONST; }
"k"			{ g_Val.str = "k"; return tSTRCONST; }
"l"			{ g_Val.str = "l"; return tSTRCONST; }
"m"			{ g_Val.str = "m"; return tSTRCONST; }
"n"			{ g_Val.str = "n"; return tSTRCONST; }
"o"			{ g_Val.str = "o";g_bSam = 1;  return tSTRCONST; }
"p"			{ g_Val.str = "p"; return tSTRCONST; }
"r"			{ g_Val.str = "r"; return tSTRCONST; }
"s"			{ g_Val.str = "s"; return tSTRCONST; }
"t"			{ g_Val.str = "t"; return tSTRCONST; }
"u"			{ g_Val.str = "u"; g_bSam = 1; return tSTRCONST; }
"w"			{ g_Val.str = "v"; return tSTRCONST; }
"y"			{ g_Val.str = "I"; g_bSam = 1; return tSTRCONST; }
"z"			{ g_Val.str = "z"; return tSTRCONST; }

"A"			{ g_Val.str = "a"; g_bSam = 1; return tSTRCONST; }
"B"			{ g_Val.str = "b"; return tSTRCONST; }
"C"			{ g_Val.str = "ts"; return tSTRCONST; }
"D"			{ g_Val.str = "d"; return tSTRCONST; }
"E"			{ g_Val.str = "e"; g_bSam = 1; return tSTRCONST; }
"F"			{ g_Val.str = "f"; return tSTRCONST; }
"G"			{ g_Val.str = "g"; return tSTRCONST; }
"H"			{ g_Val.str = "x"; return tSTRCONST; }
"I"			{ g_Val.str = "i"; g_bSam = 1; return tSTRCONST; }
"J"			{ g_Val.str = "j"; return tSTRCONST; }
"K"			{ g_Val.str = "k"; return tSTRCONST; }
"L"			{ g_Val.str = "l"; return tSTRCONST; }
"M"			{ g_Val.str = "m"; return tSTRCONST; }
"N"			{ g_Val.str = "n"; return tSTRCONST; }
"O"			{ g_Val.str = "o"; g_bSam = 1; return tSTRCONST; }
"P"			{ g_Val.str = "p"; return tSTRCONST; }
"R"			{ g_Val.str = "r"; return tSTRCONST; }
"S"			{ g_Val.str = "s"; return tSTRCONST; }
"T"			{ g_Val.str = "t"; return tSTRCONST; }
"U"			{ g_Val.str = "u"; g_bSam = 1; return tSTRCONST; }
"W"			{ g_Val.str = "v"; return tSTRCONST; }
"Y"			{ g_Val.str = "I"; g_bSam = 1; return tSTRCONST; }
"Z"			{ g_Val.str = "z"; return tSTRCONST; }

"!"                      { g_Val.str = "!"; return tINTERP; }
"?"                      { g_Val.str = "?"; return tINTERP; }
","                      { g_Val.str = ","; return tINTERP; }
":"                      { g_Val.str = ","; return tINTERP; }
"-"                      { g_Val.str = " "; return tINTERP; }
"."	                 { g_Val.str = "."; return tINTERP; }

<<EOF>>					{ yy_delete_buffer(yy_current_buffer); yyterminate(); }
								

(0|([1-9][0-9]*))?"."[0-9]+	{ g_Val.FloatConst = (float)atof(yytext); return tFLOATCONST; }
0|([1-9][0-9]*)					{ g_Val.IntConst = atoi(yytext); return tINTCONST; }

.								{ 
									yyerror("Unrecognized character: %s", yytext); 
									yy_delete_buffer(yy_current_buffer);
									yyterminate();
									return 0; 
								}

%% 